/* @fileoverview 
 * Provides full Bootstrap based, multi-instance WYSIWYG editor.
 *
 * Name     = bootstrap-wysiwyg
 * Author   = Various, see LICENCE
 * Version  = v2.0.2
 * About    = A tiny Bootstrap and jQuery based WYSIWYG rich text editor based on the browser function execCommand.
*/

!function(e,t){"use strict";function n(n,o){this.selectedRange=null,this.editor=t(n);var a=t(n),i={hotKeys:{"Ctrl+b meta+b":"bold","Ctrl+i meta+i":"italic","Ctrl+u meta+u":"underline","Ctrl+z":"undo","Ctrl+y meta+y meta+shift+z":"redo","Ctrl+l meta+l":"justifyleft","Ctrl+r meta+r":"justifyright","Ctrl+e meta+e":"justifycenter","Ctrl+j meta+j":"justifyfull","Shift+tab":"outdent",tab:"indent"},toolbarSelector:"[data-role=editor-toolbar]",commandRole:"edit",activeToolbarClass:"btn-info",selectionMarker:"edit-focus-marker",selectionColor:"darkgrey",dragAndDropImages:!0,keypressTimeout:200,fileUploadError:function(e,t){console.log("File upload error",e,t)}},r=t.extend(!0,{},i,o),l="a[data-"+r.commandRole+"],button[data-"+r.commandRole+"],input[type=button][data-"+r.commandRole+"]";this.bindHotkeys(a,r,l),r.dragAndDropImages&&this.initFileDrops(a,r,l),this.bindToolbar(a,t(r.toolbarSelector),r,l),a.attr("contenteditable",!0).on("mouseup keyup mouseout",function(){this.saveSelection(),this.updateToolbar(a,l,r)}.bind(this)),t(e).bind("touchend",function(e){if(this.getCurrentRange){var t=a.is(e.target)||a.has(e.target).length>0,n=this.getCurrentRange();n&&n.startContainer===n.endContainer&&n.startOffset===n.endOffset&&!t||(this.saveSelection(),this.updateToolbar(a,l,r))}})}n.prototype.readFileIntoDataUrl=function(e){var n=t.Deferred(),o=new FileReader;return o.onload=function(e){n.resolve(e.target.result)},o.onerror=n.reject,o.onprogress=n.notify,o.readAsDataURL(e),n.promise()},n.prototype.cleanHtml=function(e){var n=this;if(!0===t(n).data("wysiwyg-html-mode")&&(t(n).html(t(n).text()),t(n).attr("contenteditable",!0),t(n).data("wysiwyg-html-mode",!1)),!0===e&&t(n).parent().is("form")){var o=t(n).html;if(t(o).has("img").length){var a=t("img",t(o)),i=[],r=t(n).parent();t.each(a,function(e,n){t(n).attr("src").match(/^data:image\/.*$/)&&(i.push(a[e]),t(r).prepend("<input value='"+t(n).attr("src")+"' type='hidden' name='postedimage/"+e+"' />"),t(n).attr("src","postedimage/"+e))})}}var l=t(n).html();return l&&l.replace(/(<br>|\s|<div><br><\/div>|&nbsp;)*$/,"")},n.prototype.updateToolbar=function(e,n,o){o.activeToolbarClass&&t(o.toolbarSelector).find(n).each(function(){var e=t(this),n=e.data(o.commandRole).split(" "),a=n[0];n.length>1&&document.queryCommandEnabled(a)&&document.queryCommandValue(a)===n[1]?e.addClass(o.activeToolbarClass):1===n.length&&document.queryCommandEnabled(a)&&document.queryCommandState(a)?e.addClass(o.activeToolbarClass):e.removeClass(o.activeToolbarClass)})},n.prototype.execCommand=function(e,t,n,o,a){var i=e.split(" "),r=i.shift(),l=i.join(" ")+(t||""),s=e.split("-");1===s.length?document.execCommand(r,!1,l):"format"===s[0]&&2===s.length&&document.execCommand("formatBlock",!1,s[1]),n.trigger("change"),this.updateToolbar(n,a,o)},n.prototype.bindHotkeys=function(e,n,o){var a=this;t.each(n.hotKeys,function(i,r){r&&t(e).keydown(i,function(i){e.attr("contenteditable")&&t(e).is(":visible")&&(i.preventDefault(),i.stopPropagation(),a.execCommand(r,null,e,n,o))}).keyup(i,function(n){e.attr("contenteditable")&&t(e).is(":visible")&&(n.preventDefault(),n.stopPropagation())})}),e.keyup(function(){e.trigger("change")})},n.prototype.getCurrentRange=function(){var t,n;return e.getSelection?(t=e.getSelection()).getRangeAt&&t.rangeCount&&(n=t.getRangeAt(0)):document.selection&&(n=document.selection.createRange()),n},n.prototype.saveSelection=function(){this.selectedRange=this.getCurrentRange()},n.prototype.restoreSelection=function(){var t;if(e.getSelection||document.createRange){if(t=e.getSelection(),this.selectedRange){try{t.removeAllRanges()}catch(e){document.body.createTextRange().select(),document.selection.empty()}t.addRange(this.selectedRange)}}else document.selection&&this.selectedRange&&this.selectedRange.select()},n.prototype.toggleHtmlEdit=function(e){if(!0!==e.data("wysiwyg-html-mode")){var n=e.html(),o=t("<pre />");t(o).append(document.createTextNode(n)),t(o).attr("contenteditable",!0),t(e).html(" "),t(e).append(t(o)),t(e).attr("contenteditable",!1),t(e).data("wysiwyg-html-mode",!0),t(o).focus()}else t(e).html(t(e).text()),t(e).attr("contenteditable",!0),t(e).data("wysiwyg-html-mode",!1),t(e).focus()},n.prototype.insertFiles=function(e,n,o,a){var i=this;o.focus(),t.each(e,function(e,r){/^image\//.test(r.type)||/.+\.(bmp|gif|jpg|jpeg|png)$/.test(r.name.toLowerCase())?t.when(i.readFileIntoDataUrl(r)).done(function(e){i.execCommand("insertimage",e,o,n,a),o.trigger("image-inserted")}).fail(function(e){n.fileUploadError("file-reader",e)}):n.fileUploadError("unsupported-file-type",r.type)})},n.prototype.markSelection=function(e,t){this.restoreSelection(),document.queryCommandSupported("hiliteColor")&&document.execCommand("hiliteColor",!1,e||"transparent"),this.saveSelection()},n.prototype.bindToolbar=function(n,o,a,i){var r=this;o.find(i).click(function(){r.restoreSelection(),n.focus(),"html"===n.data(a.commandRole)?r.toggleHtmlEdit(n):r.execCommand(t(this).data(a.commandRole),null,n,a,i),r.saveSelection()}),o.find("[data-toggle=dropdown]").on("click",function(){r.markSelection(a.selectionColor,a)}),o.on("hide.bs.dropdown",function(){r.markSelection(!1,a)}),o.find("input[type=text][data-"+a.commandRole+"]").on("webkitspeechchange change",function(){var o=this.value;this.value="",r.restoreSelection(),""===e.getSelection().toString().trim()&&o&&(r.editor.append("<span>"+o+"</span>"),function(t){if(e.getSelection&&document.createRange){var n=e.getSelection(),o=document.createRange();o.selectNodeContents(t),n.removeAllRanges(),n.addRange(o)}else if(document.selection&&document.body.createTextRange){var a=document.body.createTextRange();a.moveToElementText(t),a.select()}}(t("span:last",r.editor)[0])),o&&(n.focus(),r.execCommand(t(this).data(a.commandRole),o,n,a,i)),r.saveSelection()}).on("blur",function(){t(this);r.markSelection(!1,a)}),o.find("input[type=file][data-"+a.commandRole+"]").change(function(){r.restoreSelection(),"file"===this.type&&this.files&&this.files.length>0&&r.insertFiles(this.files,a,n,i),r.saveSelection(),this.value=""})},n.prototype.initFileDrops=function(e,t,n){var o=this;e.on("dragenter dragover",!1).on("drop",function(a){var i=a.originalEvent.dataTransfer;a.stopPropagation(),a.preventDefault(),i&&i.files&&i.files.length>0&&o.insertFiles(i.files,t,e,n)})},t.fn.wysiwyg=function(e){new n(this,e);return this},t.fn.cleanHtml=function(){return n.prototype.cleanHtml.apply(this)}}(window,window.jQuery);
